'' MPE_SPI_DOGM_006
'' DOGM 4-PIN 2008-01 by deSilva
'' dogfont_1  2008-01 by Clemens
'' Modified 2009-09 by Nyx

'' Before use you MUST verify settings in initdogm section, according to your setup
'' Observe: Contrast may need tweaking
''          Boostercircuit must never boost beyond 13volts

CON
    _clkmode        = xtal1 + pll16x
    _xinfreq        = 5_000_000

    SD     = 0              ' using I/O 0..3 change whenever appropriate
    SCL    = 1
    A0     = 2
    CS     = 3
    LINES  = 64             ' display size
    COLUMNS= 128
VAR
    BYTE framebuffer[COLUMNS*LINES/8]
PUB init(upsidedown)
  bytefill(@framebuffer, 0, lines*columns/8)
  OUTA[CS]~~
  OUTA[SCL]~~
  DIRA[SD..CS]~~
  spiwrite(@initDOGM, constant(@initDOGMend-@initDOGM) , 0)
  IF upsidedown
    spiwrite(string($A0,$C8),2,0)
  spiwrite(string($B0,$10),3,0)
       
PUB refresh | i
  REPEAT i FROM 0 TO constant(LINES/8-1) 
    pageDOGM &= $f0
    pageDOGM |= i
    spiwrite(@pageDOGM, constant(@pageDOGMend-@pageDOGM) , 0)
    spiwrite(@framebuffer[i*COLUMNS], COLUMNS, 1)
        
pub write(data, wcol, wpage)                  'xor data with framebuffer coulumn*page
  framebuffer[wpage*COLUMNS+wcol]^=data
pub dot(bit, dcol,drow)                       'toggle "bit" at x,y
  write((bit&1)<<(drow//8), dcol, drow/8)
  
pub line(scol,srow,dcol,drow)|xdiff, ydiff, px, x
  xdiff:=(dcol-scol)
  ydiff:=(drow-srow)
  px:=^^((xdiff*xdiff)+(ydiff*ydiff))
  repeat x from 0 to px  
    dot(1,scol+(x*xdiff/px),srow+(x*ydiff/px))
    
pub box(scol,srow,dcol,drow,fill)|xdiff, ydiff, x
  line(scol, srow, dcol, srow)
  line(dcol,srow, dcol, drow)
  line(dcol, drow, scol, drow)
  line(scol,drow,scol,srow)
  if fill
    repeat x from srow+1 to drow-1
      line(scol,x,dcol,x)
      
pub str(strAddr, col, row)| letter, i , j, data
  REPEAT WHILE letter := BYTE[strAddr++]
    case letter
      196: letter:= 127
      214: letter:= 128
      220: letter:= 129
      223: letter:= 130
      228: letter:= 131
      246: letter:= 132
      252: letter:= 133
    repeat i from 0 to ((charspace[letter-31]-127)-(charspace[letter-32]-127)+3)
      data:=byte[@fontmap[(letter-32)*4+(charspace[letter-32]-127)]+i]
      col++
      repeat j from 0 to 7
        dot(data&1, col, row+j)
        data>>=1
    col++   
PRI spiwrite(dataAddr, nmbBytes, thisA0): data

  outa[CS]~
  outa[A0] := thisA0
  REPEAT WHILE nmbBytes-- > 0
    IF dataAddr
      data := BYTE[dataAddr++] >< 8 'reverse each byte         
    REPEAT 8                   'transfer from D7 to D0
      outa[SCL]~               'clock goes low
      outa[SD] := data
      outa[SCL]~~              'transfer at rising edge
      data >>= 1
  outa[a0]~                                             
  outa[CS]~~


DAT           '' deSilva's initsequences
initDOGM      BYTE $40      'Start line =0
              BYTE $A1      'ADC reverse
              BYTE $C0      'reverse COM
              BYTE $A6      'normal display
              BYTE $A2      'set bias 1/9
              BYTE $2f      'set Booster
              BYTE $F8, $00 'set Booster x4
              BYTE $27      ' change here for contrast: $24..$27
              BYTE $81, $18 'set contrast ($3f to $00)
              BYTE $AC, $01 'no static indicator
              BYTE $AF      ' Display ON      
initDOGMend   BYTE

pageDOGM     BYTE $B0   ' set line
              BYTE $40
              BYTE $10        ' set low nibble
              BYTE $00        ' set high nibble
pageDOGMend  BYTE

              '' Clemen's nonmonospace font
fontmap       byte    %00000000       'Space
              byte    %00000000
                
              byte    %01011110       '!

              byte    %00000110       '"
              byte    %00000000
              byte    %00000110

              byte    %00101000       '#
              byte    %01111100
              byte    %00101000
              byte    %01111100
              byte    %00101000

              byte    %00100100       '$
              byte    %00101010
              byte    %01111111
              byte    %00101010
              byte    %00010000
              
              byte    %01100010       '%
              byte    %00011000
              byte    %01000110

              byte    %00110000       '&
              byte    %01001100
              byte    %01011010
              byte    %00100100
              byte    %01010000

              byte    %00000110       ''

              byte    %00111100       '(
              byte    %01000010

              byte    %01000010       ')
              byte    %00111100

              byte    %00101000       '*
              byte    %00010000
              byte    %01111100
              byte    %00010000
              byte    %00101000

              byte    %00010000       '+
              byte    %00111000
              byte    %00010000

              byte    %11000000       ',

              byte    %00010000       '-
              byte    %00010000
              byte    %00010000  

              byte    %01000000       '.

              byte    %01100000       '/
              byte    %00011000
              byte    %00000110
              
              
              byte    %00111100       '0
              byte    %01000010
              byte    %01000010
              byte    %00111100
              
              byte    %01000100       '1 
              byte    %01111110
              byte    %01000000

              byte    %01000100       '2
              byte    %01100010
              byte    %01010010
              byte    %01001100        
              
              byte    %01001010       '3
              byte    %01001010
              byte    %00110100

              byte    %00011110       '4
              byte    %00010000
              byte    %01111100
              byte    %00010000

              byte    %01001110       '5
              byte    %01001010
              byte    %00110010

              byte    %00111100       '6
              byte    %01001010
              byte    %01001010
              byte    %00110000

              byte    %01100010       '7
              byte    %00010010
              byte    %00001110

              byte    %00110100       '8
              byte    %01001010
              byte    %01001010
              byte    %00110100

              byte    %00001100       '9
              byte    %01010010
              byte    %01010010
              byte    %00111100

              byte    %01001000       ':
              
              byte    %10000000       ';
              byte    %01101000

              byte    %00010000       '<
              byte    %00101000
              byte    %01000100

              byte    %00101000       '=
              byte    %00101000
              byte    %00101000

              byte    %01000100       '>
              byte    %00101000
              byte    %00010000

              byte    %00000010       '?
              byte    %01010010
              byte    %00001100

              byte    %00111100       '@
              byte    %01000010
              byte    %01010010
              byte    %00101010
              byte    %00111100
              
              byte    %01111100       'A
              byte    %00010010
              byte    %00010010
              byte    %01111100
               
              byte    %01111110       'B
              byte    %01001010
              byte    %01001010 
              byte    %00110100
               
              byte    %00111100       'C
              byte    %01000010
              byte    %01000010 
              byte    %00100100
               
              byte    %01111110       'D
              byte    %01000010
              byte    %01000010 
              byte    %00111100
               
              byte    %01111110       'E
              byte    %01001010
              byte    %01001010 
               
              byte    %01111110       'F
              byte    %00001010
              byte    %00001010 
               
              byte    %00111100       'G
              byte    %01000010
              byte    %01010010 
              byte    %00110100
               
              byte    %01111110       'H
              byte    %00001000
              byte    %00001000 
              byte    %01111110
               
              byte    %01000010       'I
              byte    %01111110
              byte    %01000010  
               
              byte    %01000010       'J
              byte    %01000010 
              byte    %00111110
               
              byte    %01111110       'K
              byte    %00001000 
              byte    %00010100
              byte    %01100010
               
              byte    %01111110       'L
              byte    %01000000
              byte    %01000000 
               
              byte    %01111110       'M
              byte    %00000100
              byte    %00001000
              byte    %00000100
              byte    %01111110
               
              byte    %01111110       'N
              byte    %00000100
              byte    %00011000
              byte    %00100000
              byte    %01111110
               
              byte    %00111100       'O
              byte    %01000010
              byte    %01000010
              byte    %00111100
               
              byte    %01111110       'P
              byte    %00010010
              byte    %00010010
              byte    %00001100
               
              byte    %00111100       'Q
              byte    %01000010
              byte    %01000010
              byte    %10111100
               
              byte    %01111110       'R
              byte    %00010010
              byte    %00010010
              byte    %01101100
               
              byte    %01000100       'S
              byte    %01001010
              byte    %01001010
              byte    %00110000
               
              byte    %00000010       'T
              byte    %01111110
              byte    %00000010
               
              byte    %00111110       'U
              byte    %01000000
              byte    %01000000
              byte    %00111110
               
              byte    %00000110       'V
              byte    %00011000   
              byte    %01100000
              byte    %00011000
              byte    %00000110
                                                          
              byte    %00111110       'W
              byte    %01000000
              byte    %00111110 
              byte    %01000000
              byte    %00111110
               
              byte    %01000010       'X
              byte    %00100100
              byte    %00011000 
              byte    %00100100
              byte    %01000010
               
              byte    %10011110       'Y
              byte    %10100000
              byte    %10100000 
              byte    %01111110
               
              byte    %01100010       'Z
              byte    %01010010
              byte    %01001010 
              byte    %01000110

              byte    %01111110       '[
              byte    %01000010

              byte    %00000110       '\
              byte    %00011000
              byte    %01100000

              byte    %01000010       ']
              byte    %01111110

              byte    %00100000       '^
              byte    %00010000
              byte    %00100000

              byte    %10000000       '_
              byte    %10000000
              byte    %10000000
              byte    %10000000

              byte    %00000100       '`
              byte    %00001000

              byte    %00100000       'a
              byte    %01010100
              byte    %01010100 
              byte    %01111000
               
              byte    %01111110       'b
              byte    %01000100
              byte    %01000100 
              byte    %00111000
               
              byte    %00111000       'c
              byte    %01000100
              byte    %01000100 
              byte    %00101000
               
              byte    %00111000       'd
              byte    %01000100
              byte    %01000100 
              byte    %01111110
               
              byte    %00111000       'e
              byte    %01010100
              byte    %01010100 
              byte    %01011000
               
              byte    %01111100       'f
              byte    %00001010
               
              byte    %10011000       'g
              byte    %10100100
              byte    %10100100 
              byte    %01111100
               
              byte    %01111110       'h
              byte    %00000100
              byte    %00000100 
              byte    %01111000
                               
              byte    %01111010       'i
                               
              byte    %01000000       'j
              byte    %00111010 
                               
              byte    %01111110       'k
              byte    %00010000
              byte    %00101000
              byte    %01000100
               
              byte    %01111110       'l
               
              byte    %01111100       'm
              byte    %00000100
              byte    %01111000
              byte    %00000100
              byte    %01111000
               
              byte    %01111100       'n
              byte    %00000100
              byte    %00000100
              byte    %01111000
               
              byte    %00111000       'o
              byte    %01000100
              byte    %01000100
              byte    %00111000
               
              byte    %11111100       'p
              byte    %00100100
              byte    %00100100
              byte    %00011000
               
              byte    %00011000       'q
              byte    %00100100
              byte    %00100100
              byte    %11111100
               
              byte    %01111100       'r
              byte    %00000100
               
              byte    %01001000       's
              byte    %01010100
              byte    %01010100
              byte    %00100000
               
              byte    %00000100       't
              byte    %00111110
              byte    %01000100
               
              byte    %00111100       'u
              byte    %01000000
              byte    %01000000
              byte    %00111100
               
              byte    %00001100       'v
              byte    %00110000   
              byte    %01000000
              byte    %00110000
              byte    %00001100
                                  
              byte    %00111100       'w
              byte    %01000000
              byte    %00111100 
              byte    %01000000
              byte    %00111100
                                  
              byte    %01000100       'x
              byte    %00101000
              byte    %00010000 
              byte    %00101000
              byte    %01000100
                                  
              byte    %10011100       'y
              byte    %10100000   
              byte    %10100000
              byte    %01111100 
                                  
              byte    %01100100       'z
              byte    %01010100   
              byte    %01001100
               

              byte    %00001000       '{
              byte    %00110110
              byte    %01000001

              byte    %11111111       '|
              
              byte    %01000001       '}
              byte    %00110110
              byte    %00001000

              byte    %00100000       '~
              byte    %00010000
              byte    %00100000
              byte    %00010000
               
              byte    %01111101       '
              byte    %00010010
              byte    %00010010
              byte    %01111101
                                      
              byte    %00111101       '   
              byte    %01000010
              byte    %01000010
              byte    %00111101
              
              byte    %00111101       '   
              byte    %01000000
              byte    %01000000
              byte    %00111101
               
              byte    %01111100       '
              byte    %00000010
              byte    %01001010
              byte    %00110100
                              
              byte    %00100010       '    
              byte    %01010100
              byte    %01010100 
              byte    %01111010
               
              byte    %00111010       '  
              byte    %01000100
              byte    %01000100
              byte    %00111010     

               
              byte    %00111010       '
              byte    %01000000
              byte    %01000000
              byte    %00111010


'  charspace holds information about the position of a character in the fontmap relative to
'  an assumed 4 columns per Character. 127 means the character is in the assumed position.

                  'Spc   !    "    #    $    %    &    '    (    )    *    +    ,    -    .    /
charspace     byte 127, 125, 122, 121, 122, 123, 122, 123, 120, 118, 116, 117, 116, 113, 112, 109
                   '0    1    2    3    4    5    6    7    8    9    :    ;    <   =   >   ?   @
              byte 108, 108, 107, 107, 106, 106, 105, 105, 104, 104, 104, 101, 99, 98, 97, 96, 95                     
                   'A  B  C  D  E  F  G  H  I  J  K  L  M  N  O  P  Q  R  S  T  U  V  W  X  Y  Z
              byte 96,96,96,96,96,95,94,94,94,93,92,92,91,92,93,93,93,93,93,93,92,92,93,94,95,95
                   '[   /   ]   ^   _   `
              byte 95, 93, 92, 90, 89, 89
                   'a  b  c  d  e  f  g  h  i  j  k  l  m  n  o  p  q  r  s  t  u  v  w  x  y  z  
              byte 87,87,87,87,87,87,85,85,85,82,80,80,77,78,78,78,78,78,76,76,75,75,76,77,78,78
                   '{  |  }  ~              
              byte 77,76,73,72,72,72,72,72,72,72,72,72      